unit hiCtrlPaletteEx;

interface

uses Windows,Messages,Kol,Share,Debug,Win,hiIconsManager,hiIndexManager,hiBoxDrawManager;

type
  THICtrlPaletteEx = class(THIWin)
   private
    FBmp:PBitmap;
    FFace, FBorder1,FBorder2,FBlack:HPEN;
    FCaptionBack, FCaptionBackSelect, FBack, FArrow:HBRUSH;
    FCaptionH, FActive:integer;
    FList:PStrList;
    FSelectedFont, FCFont :PGraphicTool;
    TCImage, State:integer;
    CapText: string;
    Arr:PArray;
        
    procedure _Set(var Item:TData; var Val:TData);
    function _Get(Var Item:TData; var Val:TData):boolean;
    function _Count:integer;
    procedure _Add(var Val:TData);
    procedure SetNewCFont(Value:TFontRec);
    procedure SetNewSelectedFont(Value:TFontRec);
    procedure _OnClick( Sender: PObj );
    procedure _OnPaint( Sender: PControl; DC: HDC );
    procedure _onMouseDown(Sender: PControl; var Mouse: TMouseEventData); override;
    procedure _onMouseMove(Sender: PControl; var Mouse: TMouseEventData); override;
    procedure _onMouseLeave( Sender: PObj ); override;
    procedure SetBitmap(Value:HBITMAP);
    procedure SetText(const Value:string);
    procedure ReDraw(index:integer);
    procedure ReDrawAll;
   public
    _prop_Caption:string;  
    _prop_CColor:TColor;
    _prop_SColor:TColor;
    _prop_IconsManager:IIconsManager;
    _prop_IndexManager:IIndexManager;   
    _prop_BoxDrawManager:IBoxDrawManager;
    _prop_ItemHeight:integer;
    _prop_CaptionHeight:integer;
    _prop_Alignment:byte;
    _prop_Padding:integer;
    _prop_Arrow:byte;
    _prop_State:byte;
    _prop_AddType:byte;
    _prop_FlatC:boolean;
    _prop_FlatL:boolean;
    _prop_DataType:byte;
    _data_str:THI_Event;
    _event_onClick:THI_Event;
    _event_onChangeState:THI_Event;
    _event_onChange:THI_Event;
        
    constructor Create(Parent:PControl);
    destructor Destroy; override;
    procedure Init; override;
    property _prop_Strings:string write SetText;
    property _prop_CFont:TFontRec write SetNewCFont;
    property _prop_SelectedFont:TFontRec write SetNewSelectedFont;
    property _prop_Bitmap:HBITMAP write SetBitmap;
    procedure _work_doAdd0(var _Data:TData; Index:word);
    procedure _work_doAdd1(var _Data:TData; Index:word);    
    procedure _work_doClear(var _Data:TData; Index:word);
    procedure _work_doDelete(var _Data:TData; Index:word);
    procedure _work_doText(var _Data:TData; Index:word);
    procedure _work_doState(var _Data:TData; Index:word);
    procedure _work_doCaption(var _Data:TData; Index:word);
    procedure _work_doBitmap(var _Data:TData; Index:word);
    procedure _var_Text(var _Data:TData; Index:word);
    procedure _var_Count(var _Data:TData; Index:word);
    procedure _var_Array(var _Data:TData; Index:word);
    procedure _var_State(var _Data:TData; Index:word);
  end;

implementation

constructor THICtrlPaletteEx.Create;
begin
   inherited Create(Parent);
   FBmp := NewBitmap(0,0);
   FList := NewStrList;
   Control := NewPaintbox(Parent);
   SetClassLong(Control.Handle,GCL_STYLE,GetClassLong(Control.GetWindowHandle,GCL_STYLE) and not CS_DBLCLKS);
end;

destructor THICtrlPaletteEx.Destroy;
begin
   DeleteObject(FBorder1);
   DeleteObject(FBorder2);
   DeleteObject(FFace);
   DeleteObject(FBlack);
   DeleteObject(FBack);
   DeleteObject(FCaptionBack);
   DeleteObject(FCaptionBackSelect);
   DeleteObject(FArrow);
   FCFont.free;
   FSelectedFont.free;
   FList.Free;
   FBmp.free;
   inherited;
end;

procedure THICtrlPaletteEx._work_doAdd0;
begin
   FList.Add(ReadString(_Data,_data_str,''));
   ReDrawAll;
   _hi_CreateEvent(_Data, @_event_onChange);
end;

procedure THICtrlPaletteEx._work_doAdd1;
begin
   FList.Insert(0,ReadString(_Data,_data_str,''));
   ReDrawAll;
   _hi_CreateEvent(_Data, @_event_onChange);
end;

procedure THICtrlPaletteEx._work_doClear;
begin
   FList.Clear;
   ReDrawAll;
   _hi_CreateEvent(_Data, @_event_onChange);
end;

procedure THICtrlPaletteEx._work_doDelete;
var   ind:integer;
begin
   ind := ToIntIndex(_Data);
   if (ind < 0) or (ind > FList.Count - 1) then exit;
   FList.Delete(ind);
   ReDrawAll;
   _hi_CreateEvent(_Data, @_event_onChange);
end;

procedure THICtrlPaletteEx._work_doText;
begin
   FList.SetText(ReadString(_Data,_data_str), false);
   ReDrawAll;
   _hi_CreateEvent(_Data, @_event_onChange);
end;

procedure THICtrlPaletteEx.Init;
begin
   inherited;
   with Control{$ifndef F_P}^{$endif} do
    begin
     OnClick := _OnClick;
     OnPaint := _OnPaint;
    end;
   FBorder1 := CreatePen(0, 1, Color2RGB(cl3DDkShadow));
   FBorder2 := CreatePen(0, 1, Color2RGB(clBtnHighlight));
   FFace := CreatePen(0, 1, Color2RGB(Control.Color));
   FBlack := CreatePen(0, 1, Color2RGB(clBlack));
   FBack := CreateSolidBrush(Color2RGB(Control.Color)); 
   FCaptionBack := CreateSolidBrush(Color2RGB(_prop_CColor));
   FCaptionBackSelect := CreateSolidBrush(Color2RGB(_prop_SColor));
   FArrow := CreateSolidBrush(Color2RGB(clBlack)); 
   FCaptionH := _prop_CaptionHeight;
   State := _prop_State;
   CapText := _prop_Caption;
   Control.OnMouseLeave :=_OnMouseLeave;
   If State = 0 then Control.Height := FCaptionH + 1
   else Control.Height := FCaptionH + FList.Count * _prop_ItemHeight + _prop_Padding*2 + 2; 
   FActive := -2; 
end;
//////////////////////////    /////////
procedure THICtrlPaletteEx.SetBitmap;                   //
begin                                                   //
  FBmp.Handle := Value;                                 //
  if FBmp.Empty then exit;                              //
  TCImage := FBmp.Pixels[0,0];                          //
end;                                                    //
//////////////////////////////////////////////////////////
procedure THICtrlPaletteEx.SetText;
begin
   Flist.Text := Value;
end;

procedure THICtrlPaletteEx.ReDraw(index:integer);
var r:TRect;
begin
   r.Left := 0;
   r.Right := Control.Width;
   if index = -1 then
    begin
     r.Top := 0;
     r.Bottom := FCaptionH;
    end
    else begin 
     r.Top := FCaptionH + _prop_Padding + index*_prop_ItemHeight + 1;
     r.Bottom := r.Top + _prop_ItemHeight;
    end;
   InvalidateRect(Control.Handle, @r, false);
end;

procedure THICtrlPaletteEx.ReDrawAll;
begin
  If State = 1 then Control.Height := FCaptionH + FList.Count * _prop_ItemHeight + _prop_Padding*2 + 2;
end;

procedure THICtrlPaletteEx._OnClick;
begin
end;

procedure THICtrlPaletteEx._onMouseDown;
var n:integer;
begin
   inherited;
   if Mouse.y < FCaptionH then
    begin
     if State = 0 then
      begin
        State := 1;
        Control.Height := FCaptionH + FList.Count * _prop_ItemHeight + _prop_Padding*2 + 2;
      end
     else 
      begin
       State := 0;
       Control.Height := FCaptionH + 1;
      end;
       _hi_OnEvent(_event_onChangeState, State);
    end      
   else
    begin
      n := (Mouse.y - FCaptionH - _prop_Padding) div _prop_ItemHeight;
      if n <> -1 then
        if _prop_DataType = 0 then _hi_onEvent(_event_onClick, n)
         else _hi_onEvent(_event_onClick, FList.Items[n]);
    end;
end;

procedure THICtrlPaletteEx._onMouseMove;
var n,old:integer;
begin
   inherited;
   if Mouse.y > FCaptionH then
     n := (Mouse.y - FCaptionH - _prop_Padding) div _prop_ItemHeight
    else n := -1;
   if n <> FActive then
    begin
     old := FActive;
     FActive := n;
     ReDraw(old);
     ReDraw(FActive);
    end;  
end;

procedure THICtrlPaletteEx._onMouseLeave;
var old:integer;
begin
   inherited;
   old := FActive;
   FActive := -2;
   ReDraw(old);
end;

procedure THICtrlPaletteEx._OnPaint;
var idx,i, x, y, tsz, imgsz, off : integer;
    IList : PImageList;
    cbRect : TRect;
    st:TDrawState;
    Points: array[0..2] of Tpoint;
    SizeFont: TSize;
begin
    tsz := PControl(Sender).Canvas.TextExtent('W').cy; 
////////////////     //////////////////////
    if FActive = -1 then SelectObject(DC, FCaptionBackSelect)  //
    else SelectObject(DC, FCaptionBack);                       //
    if _prop_FlatC then                                        //
     begin                                                     //
      SelectObject(DC, FFace);                                 //
      Rectangle(DC,0,0,Control.Width,FCaptionH+1);             //
     end                                                       //
    else                                                       //
     begin                                                     //
      SelectObject(DC, FBorder1);                              //
      Rectangle(DC,0,0,Control.Width,FCaptionH+1);             //
      SelectObject(DC, FBorder2);                              //
      MoveToEx(DC, 0, FCaptionH - 1, nil);                     //
      LineTo(DC, 0, 0);                                        //
      LineTo(DC, Control.Width - 1, 0);                        //
     end;                                                      //
//////////////////    /////////////////////////////////////////    
    SetTextColor(DC, FCFont.Color);                                        //
    SelectObject(DC, FCFont.Handle);                                       //
    SetBkMode(DC, TRANSPARENT);                                            //
    GetTextExtentPoint32( DC, PChar(CapText), Length(CapText), SizeFont);  //
    if _prop_Arrow = 1 then i := 4 else i := 18;                           //
    Case _prop_Alignment of                                                //
     0: x := 6 + FBmp.Width;                                               //
     1: x := Control.Width - SizeFont.cx - i;                              //
     2: x := Control.Width div 2 - SizeFont.cx div 2 - i div 2;            //
    end;                                                                   //
    y := FCaptionH div 2 - SizeFont.cy div 2;                              //
    TextOut(DC, x, y,PChar(CapText), Length(CapText));                     //
///////////////////      ///////////////////////////////////    
    y := FCaptionH div 2 - FBmp.Height div 2;                          //
    FBmp.DrawTransparent(DC,x - FBmp.Width - 2,y, TCImage);            //
////////////////////////  \ ////////////////////////////
    If _prop_Arrow = 0 then begin                                      //
     SelectObject(DC, FBlack);                                         //
     SelectObject(DC, FArrow);                                         //
     y := FCaptionH div 2;                                             //
     if State = 0 then begin                                           //
      Points[0]:= MakePoint(Control.Width - 11, y - 3);                //     
      Points[1]:= MakePoint(Control.Width - 11, y + 3);                //
      Points[2]:= MakePoint(Control.Width - 8, y);                     //
     end                                                               //
     else begin                                                        //
      Points[0]:= MakePoint(Control.Width - 6, y - 2);                 //
      Points[1]:= MakePoint(Control.Width - 12, y - 2);                //
      Points[2]:= MakePoint(Control.Width - 9, y + 1);                 //
     end;                                                              //
     Polygon(DC, Points,3);                                            //
    end;                                                               //
////////////////////////     /////////////////////////    
      SelectObject(DC, FBack);                                      //
    if _prop_FlatL then                                             //
     begin                                                          //
      SelectObject(DC, FFace);                                      //
      Rectangle(DC,0,FCaptionH + 1,Control.Width,Control.Height);   //
     end                                                            //
    else                                                            //
     begin                                                          //
      SelectObject(DC, FBorder1);                                   //
      Rectangle(DC,0,FCaptionH + 1,Control.Width,Control.Height);   //
      SelectObject(DC, FBorder2);                                   //
      MoveToEx(DC, 0, Control.Height - 2, nil);                     //
      LineTo(DC, 0, FCaptionH + 1);                                 //
      LineTo(DC, Control.Width - 1, FCaptionH + 1);                 //
     end;                                                           //
//////////////////////////////////////////////////////////////////////   
    for i := 0 to FList.Count-1 do
     begin
      y := FCaptionH + _prop_Padding + i*_prop_ItemHeight + 1;  
      if Assigned(_prop_BoxDrawManager) then 
        begin
         cbRect.left := 1;
         cbRect.top := y;
         cbRect.right := Control.Width-1;
         cbRect.bottom := y + _prop_ItemHeight;
         if i = FActive then st := [odsSelected]
         else st := []; 
         _prop_BoxDrawManager.draw(Control, DC, cbRect, i, st, false, PControl(Sender).Font.Handle);
         off := _prop_BoxDrawManager.shift;
        end
      else
       begin
        if i = FActive then
         begin
         SelectObject(DC, FBorder1);                                   
         Rectangle(DC,1, y ,Control.Width - 1,y + _prop_ItemHeight);  
         end;
        off := 0;
       end;
        if (Assigned(_prop_IndexManager)) and (Assigned(_prop_IconsManager)) then
          begin
             IList := _prop_IconsManager.iconList;
             if not Assigned(IList) then exit;
             idx := _prop_IndexManager.outidx(i);
             imgsz := _prop_IconsManager.imgsz;         
             with cbRect do
             begin
                Top:= FCaptionH + _prop_Padding + i*_prop_ItemHeight + (_prop_ItemHeight - imgsz) div 2;
                Left:= 2;
                Bottom:= Top + imgsz; 
                Right:= Left + imgsz;
             end;
             if (idx < 0) or (idx > IList.Count - 1) then
               idx := SKIP;      
             IList.Draw(idx, DC, cbRect.Left, cbRect.Top);   
          end;      
      if FActive = i then
       begin
        SelectObject(DC, FSelectedFont.Handle);
        SetTextColor(DC, FSelectedFont.Color);
       end 
      else
       begin
        SelectObject(DC, Control.Font.Handle);
        SetTextColor(DC, Control.Font.Color);
       end; 
      y := y + ((_prop_ItemHeight - tsz) div 2);
      TextOut(DC, 18 + off, y, PChar(FList.Items[i]), Length(FList.Items[i]));
    end;
end;

procedure THICtrlPaletteEx.SetNewCFont;
begin
   if Assigned(FCFont) then FCFont.free;
   FCFont := NewFont;
   FCFont.Color:= Value.Color;
   Share.SetFont(FCFont,Value.Style);
   FCFont.FontName:= Value.Name;
   FCFont.FontHeight:= _hi_SizeFnt(Value.Size);
   FCFont.FontCharset:= Value.CharSet;
end;

procedure THICtrlPaletteEx.SetNewSelectedFont;
begin
   if Assigned(FSelectedFont) then FSelectedFont.free;
   FSelectedFont := NewFont;
   FSelectedFont.Color:= Value.Color;
   Share.SetFont(FSelectedFont,Value.Style);
   FSelectedFont.FontName:= Value.Name;
   FSelectedFont.FontHeight:= _hi_SizeFnt(Value.Size);
   FSelectedFont.FontCharset:= Value.CharSet;
end;

procedure THICtrlPaletteEx._work_doBitmap;
begin
  FBmp.Assign(ToBitmap(_Data));
  TCImage := FBmp.Pixels[0,0];   
  Control.Invalidate;
end;

procedure THICtrlPaletteEx._work_doState;
begin
   State := ReadInteger(_data,null);
   If  State = 0 then Control.Height := FCaptionH + 1
   else Control.Height := FCaptionH + FList.Count * _prop_ItemHeight + _prop_Padding*2 + 2; 
   _hi_OnEvent(_event_onChangeState, State);   
end;

procedure THICtrlPaletteEx._work_doCaption;
begin
     CapText := ReadString(_data,null);
     ReDraw(-1);
end;

procedure THICtrlPaletteEx._Set;
var   ind:integer;
begin
   ind := ToIntIndex(Item);
   if (ind >= 0) and (ind < FList.Count) then
      FList.Items[ind] := ToString(Val);
end;

procedure THICtrlPaletteEx._Add;
begin
   FList.Add(ToString(val));
   ReDrawAll;
end;

function THICtrlPaletteEx._Get;
var   ind:integer;
begin
   ind := ToIntIndex(Item);
   if (ind >= 0) and (ind < FList.Count) then begin
      Result := true;
      dtString(Val,FList.Items[ind]);
   end else
      Result := false;
end;

function THICtrlPaletteEx._Count;
begin
   Result := FList.Count;
end;

procedure THICtrlPaletteEx._var_Array;
begin
   if Arr = nil then Arr := CreateArray(_Set, _Get, _Count, _Add);
   dtArray(_Data,Arr);
end;

procedure THICtrlPaletteEx._var_Text;
begin
   dtString(_Data,FList.Text);
end;

procedure THICtrlPaletteEx._var_Count;
begin
  dtInteger(_Data,FList.Count);
end;

procedure THICtrlPaletteEx._var_State;
begin
   dtInteger(_data, State);
end;

end.
